# \Thelia\Model\BaseCoupon

## Summary

Methods
Properties
Constants
__construct()
isModified()
isColumnModified()
getModifiedColumns()
isNew()
setNew()
isDeleted()
setDeleted()
resetModified()
equals()
hashCode()
getVirtualColumns()
hasVirtualColumn()
getVirtualColumn()
setVirtualColumn()
importFrom()
exportTo()
__sleep()
getId()
getCode()
getAction()
getValue()
getUsed()
getAvailableSince()
getDateLimit()
getActivate()
getCreatedAt()
getUpdatedAt()
setId()
setCode()
setAction()
setValue()
setUsed()
setAvailableSince()
setDateLimit()
setActivate()
setCreatedAt()
setUpdatedAt()
hasOnlyDefaultValues()
hydrate()
ensureConsistency()
reload()
delete()
save()
getByName()
getByPosition()
toArray()
setByName()
setByPosition()
fromArray()
buildCriteria()
buildPkeyCriteria()
getPrimaryKey()
setPrimaryKey()
isPrimaryKeyNull()
copyInto()
copy()
initRelation()
clearCouponRules()
resetPartialCouponRules()
initCouponRules()
getCouponRules()
setCouponRules()
countCouponRules()
addCouponRule()
removeCouponRule()
clear()
clearAllReferences()
__toString()
keepUpdateDateUnchanged()
preSave()
postSave()
preInsert()
postInsert()
preUpdate()
postUpdate()
preDelete()
postDelete()
__call()
No public properties found
TABLE_MAP
log()
doSave()
doInsert()
doUpdate()
doAddCouponRule()
$new
$deleted
$modifiedColumns
$virtualColumns
$id
$code
$action
$value
$used
$available_since
$date_limit
$activate
$created_at
$updated_at
$collCouponRules
$collCouponRulesPartial
$alreadyInSave
$couponRulesScheduledForDeletion
N/A
No private methods found
No private properties found
N/A
abstract

File
  Model/Base/Coupon.php
Package
  \Default
Class hierarchy
  \Thelia\Model\Base\Coupon

## Tags

None found

## Constants

### TABLE_MAP

    TABLE_MAP

TableMap class name

#

## Tags

None found

## Properties

### $new

    $new : boolean

attribute to determine if this object has previously been saved.

#### Type

boolean

#

## Tags

None found

### $deleted

    $deleted : boolean

attribute to determine whether this object has been deleted.

#### Type

boolean

#

## Tags

None found

### $modifiedColumns

    $modifiedColumns : array

The columns that have been modified in current object.

Tracking modified columns allows us to only update modified columns.

#### Type

array

#

## Tags

None found

### $virtualColumns

    $virtualColumns : array

The (virtual) columns that are added at runtime The formatters can add supplementary columns based on a resultset

#### Type

array

#

## Tags

None found

### $id

    $id : int

The value for the id field.

#### Type

int

#

## Tags

None found

### $code

    $code : string

The value for the code field.

#### Type

string

#

## Tags

None found

### $action

    $action : string

The value for the action field.

#### Type

string

#

## Tags

None found

### $value

    $value : double

The value for the value field.

#### Type

double

#

## Tags

None found

### $used

    $used : int

The value for the used field.

#### Type

int

#

## Tags

None found

### $available_since

    $available_since : string

The value for the available_since field.

#### Type

string

#

## Tags

None found

### $date_limit

    $date_limit : string

The value for the date_limit field.

#### Type

string

#

## Tags

None found

### $activate

    $activate : int

The value for the activate field.

#### Type

int

#

## Tags

None found

### $created_at

    $created_at : string

The value for the created_at field.

#### Type

string

#

## Tags

None found

### $updated_at

    $updated_at : string

The value for the updated_at field.

#### Type

string

#

## Tags

None found

### $collCouponRules

    $collCouponRules : \Propel\Runtime\Collection\ObjectCollection|\Thelia\Model\CouponRule[]

#### Type

\Propel\Runtime\Collection\ObjectCollection|\Thelia\Model\CouponRule[] — Collection to store aggregation of ChildCouponRule objects.

#

## Tags

None found

### $collCouponRulesPartial

    $collCouponRulesPartial

#

## Tags

None found

### $alreadyInSave

    $alreadyInSave : boolean

Flag to prevent endless save loop, if this object is referenced by another object which falls in this transaction.

#### Type

boolean

#

## Tags

None found

### $couponRulesScheduledForDeletion

    $couponRulesScheduledForDeletion : \Propel\Runtime\Collection\ObjectCollection

An array of objects scheduled for deletion.

#### Type

\Propel\Runtime\Collection\ObjectCollection

#

## Tags

None found

## Methods

### __construct()

    __construct()

Initializes internal state of Thelia\Model\Base\Coupon object.

#

## Tags

None found

### isModified()

    isModified() : boolean

Returns whether the object has been modified.

#### Returns

boolean —

True if the object has been modified.

#

## Tags

None found

### isColumnModified()

    isColumnModified(string $col) : boolean

Has specified column been modified?

#### Parameters

string | $col | column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID

#### Returns

boolean —

True if $col has been modified.

#

## Tags

None found

### getModifiedColumns()

    getModifiedColumns() : array

Get the columns that have been modified in this object.

#### Returns

array —

A unique list of the modified column names for this object.

#

## Tags

None found

### isNew()

    isNew() : \Thelia\Model\Base\true,

Returns whether the object has ever been saved. This will be false, if the object was retrieved from storage or was created and then saved.

#### Returns

\Thelia\Model\Base\true, —

if the object has never been persisted.

#

## Tags

None found

### setNew()

    setNew(boolean $b)

Setter for the isNew attribute. This method will be called by Propel-generated children and objects.

#### Parameters

boolean | $b | the state of the object.

#

## Tags

None found

### isDeleted()

    isDeleted() : boolean

Whether this object has been deleted.

#### Returns

boolean —

The deleted state of this object.

#

## Tags

None found

### setDeleted()

    setDeleted(boolean $b) : void

Specify whether this object has been deleted.

#### Parameters

boolean | $b | The deleted state of this object.

#

## Tags

None found

### resetModified()

    resetModified(string $col) : void

Sets the modified state for the object to be false.

#### Parameters

string | $col | If supplied, only the specified column is reset.

#

## Tags

None found

### equals()

    equals( $obj) : \Thelia\Model\Base\Whether

Compares this with another <code>Coupon</code> instance. If <code>obj</code> is an instance of <code>Coupon</code>, delegates to <code>equals(Coupon)</code>. Otherwise, returns <code>false</code>.

#### Parameters

| $obj |

#### Returns

\Thelia\Model\Base\Whether —

equal to the object specified.

#

## Tags

None found

### hashCode()

    hashCode() : int

If the primary key is not null, return the hashcode of the primary key. Otherwise, return the hash code of the object.

#### Returns

int —

Hashcode

#

## Tags

None found

### getVirtualColumns()

    getVirtualColumns() : array

Get the associative array of the virtual columns in this object

#### Returns

array

#

## Tags

None found

### hasVirtualColumn()

    hasVirtualColumn( $name) : boolean

Checks the existence of a virtual column in this object

#### Parameters

| $name |

#### Returns

boolean

#

## Tags

None found

### getVirtualColumn()

    getVirtualColumn( $name) : mixed

Get the value of a virtual column in this object

#### Parameters

| $name |

#### Returns

mixed

#

## Tags

None found

### setVirtualColumn()

    setVirtualColumn(string $name, mixed $value) : \Thelia\Model\Base\Coupon

Set the value of a virtual column in this object

#### Parameters

string | $name | The virtual column name
mixed | $value | The value to give to the virtual column

#### Returns

\Thelia\Model\Base\Coupon —

The current object, for fluid interface

#

## Tags

None found

### importFrom()

    importFrom(mixed $parser, string $data) : \Thelia\Model\Base\Coupon

Populate the current object from a string, using a given parser format <code> $book = new Book(); $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}'); </code>

#### Parameters

mixed | $parser | A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
string | $data | The source data to import from

#### Returns

\Thelia\Model\Base\Coupon —

The current object, for fluid interface

#

## Tags

None found

### exportTo()

    exportTo(mixed $parser, boolean $includeLazyLoadColumns) : string

Export the current object properties to a string, using a given parser format <code> $book = BookQuery::create()->findPk(9012); echo $book->exportTo('JSON'); => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}'); </code>

#### Parameters

mixed | $parser | A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
boolean | $includeLazyLoadColumns | (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.

#### Returns

string —

The exported data

#

## Tags

None found

### __sleep()

    __sleep()

Clean up internal collections prior to serializing Avoids recursive loops that turn into segmentation faults when serializing

#

## Tags

None found

### getId()

    getId() : int

Get the [id] column value.

#### Returns

int

#

## Tags

None found

### getCode()

    getCode() : string

Get the [code] column value.

#### Returns

string

#

## Tags

None found

### getAction()

    getAction() : string

Get the [action] column value.

#### Returns

string

#

## Tags

None found

### getValue()

    getValue() : double

Get the [value] column value.

#### Returns

double

#

## Tags

None found

### getUsed()

    getUsed() : int

Get the [used] column value.

#### Returns

int

#

## Tags

None found

### getAvailableSince()

    getAvailableSince(string $format) : mixed

Get the [optionally formatted] temporal [available_since] column value.

#### Parameters

string | $format | The date/time format string (either date()-style or strftime()-style). If format is NULL, then the raw \DateTime object will be returned.

#### Throws

\Propel\Runtime\Exception\PropelException
  - if unable to parse/validate the date/time value.

#### Returns

mixed —

Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00

#

## Tags

None found

### getDateLimit()

    getDateLimit(string $format) : mixed

Get the [optionally formatted] temporal [date_limit] column value.

#### Parameters

string | $format | The date/time format string (either date()-style or strftime()-style). If format is NULL, then the raw \DateTime object will be returned.

#### Throws

\Propel\Runtime\Exception\PropelException
  - if unable to parse/validate the date/time value.

#### Returns

mixed —

Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00

#

## Tags

None found

### getActivate()

    getActivate() : int

Get the [activate] column value.

#### Returns

int

#

## Tags

None found

### getCreatedAt()

    getCreatedAt(string $format) : mixed

Get the [optionally formatted] temporal [created_at] column value.

#### Parameters

string | $format | The date/time format string (either date()-style or strftime()-style). If format is NULL, then the raw \DateTime object will be returned.

#### Throws

\Propel\Runtime\Exception\PropelException
  - if unable to parse/validate the date/time value.

#### Returns

mixed —

Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00

#

## Tags

None found

### getUpdatedAt()

    getUpdatedAt(string $format) : mixed

Get the [optionally formatted] temporal [updated_at] column value.

#### Parameters

string | $format | The date/time format string (either date()-style or strftime()-style). If format is NULL, then the raw \DateTime object will be returned.

#### Throws

\Propel\Runtime\Exception\PropelException
  - if unable to parse/validate the date/time value.

#### Returns

mixed —

Formatted date/time value as string or \DateTime object (if format is NULL), NULL if column is NULL, and 0 if column value is 0000-00-00 00:00:00

#

## Tags

None found

### setId()

    setId(int $v) : \Thelia\Model\Coupon

Set the value of [id] column.

#### Parameters

int | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setCode()

    setCode(string $v) : \Thelia\Model\Coupon

Set the value of [code] column.

#### Parameters

string | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setAction()

    setAction(string $v) : \Thelia\Model\Coupon

Set the value of [action] column.

#### Parameters

string | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setValue()

    setValue(double $v) : \Thelia\Model\Coupon

Set the value of [value] column.

#### Parameters

double | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setUsed()

    setUsed(int $v) : \Thelia\Model\Coupon

Set the value of [used] column.

#### Parameters

int | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setAvailableSince()

    setAvailableSince(mixed $v) : \Thelia\Model\Coupon

Sets the value of [available_since] column to a normalized version of the date/time value specified.

#### Parameters

mixed | $v | string, integer (timestamp), or \DateTime value. Empty strings are treated as NULL.

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setDateLimit()

    setDateLimit(mixed $v) : \Thelia\Model\Coupon

Sets the value of [date_limit] column to a normalized version of the date/time value specified.

#### Parameters

mixed | $v | string, integer (timestamp), or \DateTime value. Empty strings are treated as NULL.

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setActivate()

    setActivate(int $v) : \Thelia\Model\Coupon

Set the value of [activate] column.

#### Parameters

int | $v | new value

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setCreatedAt()

    setCreatedAt(mixed $v) : \Thelia\Model\Coupon

Sets the value of [created_at] column to a normalized version of the date/time value specified.

#### Parameters

mixed | $v | string, integer (timestamp), or \DateTime value. Empty strings are treated as NULL.

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### setUpdatedAt()

    setUpdatedAt(mixed $v) : \Thelia\Model\Coupon

Sets the value of [updated_at] column to a normalized version of the date/time value specified.

#### Parameters

mixed | $v | string, integer (timestamp), or \DateTime value. Empty strings are treated as NULL.

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### hasOnlyDefaultValues()

    hasOnlyDefaultValues() : boolean

Indicates whether the columns in this object are only set to default values.

This method can be used in conjunction with isModified() to indicate whether an object is both modified and has some values set which are non-default.

#### Returns

boolean —

Whether the columns in this object are only been set with default values.

#

## Tags

None found

### hydrate()

    hydrate(array $row, int $startcol, boolean $rehydrate, string $indexType) : int

Hydrates (populates) the object variables with values from the database resultset.

An offset (0-based "start column") is specified so that objects can be hydrated with a subset of the columns in the resultset rows. This is needed, for example, for results of JOIN queries where the resultset row includes columns from two or more tables.

#### Parameters

array | $row | The row returned by DataFetcher->fetch().
int | $startcol | 0-based offset column which indicates which restultset column to start with.
boolean | $rehydrate | Whether this object is being re-hydrated from the database.
string | $indexType | The index type of $row. Mostly DataFetcher->getIndexType(). One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.

#### Throws

\Propel\Runtime\Exception\PropelException
  - Any caught Exception will be rewrapped as a PropelException.

#### Returns

int —

next starting column

#

## Tags

None found

### ensureConsistency()

    ensureConsistency()

Checks and repairs the internal consistency of the object.

This method is executed after an already-instantiated object is re-hydrated from the database. It exists to check any foreign keys to make sure that the objects related to the current object are correct based on foreign key.

You can override this method in the stub class, but you should always invoke the base method from the overridden method (i.e. parent::ensureConsistency()), in case your model changes.

#### Throws

\Propel\Runtime\Exception\PropelException

#

## Tags

None found

### reload()

    reload(boolean $deep, \Propel\Runtime\Connection\ConnectionInterface $con) : void

Reloads this object from datastore based on primary key and (optionally) resets all associated objects.

This will only work if the object has been saved and has a valid primary key set.

#### Parameters

boolean | $deep | (optional) Whether to also de-associated any related objects.
\Propel\Runtime\Connection\ConnectionInterface | $con | (optional) The ConnectionInterface connection to use.

#### Throws

\Propel\Runtime\Exception\PropelException
  - if this object is deleted, unsaved or doesn't have pk match in db

#

## Tags

None found

### delete()

    delete(\Propel\Runtime\Connection\ConnectionInterface $con) : void

Removes this object from datastore and sets delete attribute.

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Throws

\Propel\Runtime\Exception\PropelException

#

See also

## Tags

None found

### save()

    save(\Propel\Runtime\Connection\ConnectionInterface $con) : int

Persists this object to the database.

If the object is new, it inserts it; otherwise an update is performed. All modified related objects will also be persisted in the doSave() method. This method wraps all precipitate database operations in a single transaction.

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Throws

\Propel\Runtime\Exception\PropelException

#### Returns

int —

The number of rows affected by this insert/update and any referring fk objects' save() operations.

#

See also

## Tags

None found

### getByName()

    getByName(string $name, string $type) : mixed

Retrieves a field from the object by name passed in as a string.

#### Parameters

string | $name | name
string | $type | The type of fieldname the $name is of: one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. Defaults to TableMap::TYPE_PHPNAME.

#### Returns

mixed —

Value of field.

#

## Tags

None found

### getByPosition()

    getByPosition(int $pos) : mixed

Retrieves a field from the object by Position as specified in the xml schema.

Zero-based.

#### Parameters

int | $pos | position in xml schema

#### Returns

mixed —

Value of field at $pos

#

## Tags

None found

### toArray()

    toArray(string $keyType, boolean $includeLazyLoadColumns, array $alreadyDumpedObjects, boolean $includeForeignObjects) : array

Exports the object as an array.

You can specify the key type of the array by passing one of the class type constants.

#### Parameters

string | $keyType | (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME, TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. Defaults to TableMap::TYPE_PHPNAME.
boolean | $includeLazyLoadColumns | (optional) Whether to include lazy loaded columns. Defaults to TRUE.
array | $alreadyDumpedObjects | List of objects to skip to avoid recursion
boolean | $includeForeignObjects | (optional) Whether to include hydrated related objects. Default to FALSE.

#### Returns

array —

an associative array containing the field names (as keys) and field values

#

## Tags

None found

### setByName()

    setByName(string $name, mixed $value, string $type) : void

Sets a field from the object by name passed in as a string.

#### Parameters

string | $name |
mixed | $value | field value
string | $type | The type of fieldname the $name is of: one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. Defaults to TableMap::TYPE_PHPNAME.

#

## Tags

None found

### setByPosition()

    setByPosition(int $pos, mixed $value) : void

Sets a field from the object by Position as specified in the xml schema.

Zero-based.

#### Parameters

int | $pos | position in xml schema
mixed | $value | field value

#

## Tags

None found

### fromArray()

    fromArray(array $arr, string $keyType) : void

Populates the object using an array.

This is particularly useful when populating an object from one of the request arrays (e.g. $_POST). This method goes through the column names, checking to see whether a matching key exists in populated array. If so the setByName() method is called for that column.

You can specify the key type of the array by additionally passing one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_STUDLYPHPNAME, TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM. The default key type is the column's TableMap::TYPE_PHPNAME.

#### Parameters

array | $arr | An array to populate the object from.
string | $keyType | The type of keys the array uses.

#

## Tags

None found

### buildCriteria()

    buildCriteria() : \Propel\Runtime\ActiveQuery\Criteria

Build a Criteria object containing the values of all modified columns in this object.

#### Returns

\Propel\Runtime\ActiveQuery\Criteria —

The Criteria object containing all modified values.

#

## Tags

None found

### buildPkeyCriteria()

    buildPkeyCriteria() : \Propel\Runtime\ActiveQuery\Criteria

Builds a Criteria object containing the primary key for this object.

Unlike buildCriteria() this method includes the primary key values regardless of whether or not they have been modified.

#### Returns

\Propel\Runtime\ActiveQuery\Criteria —

The Criteria object containing value(s) for primary key(s).

#

## Tags

None found

### getPrimaryKey()

    getPrimaryKey() : int

Returns the primary key for this object (row).

#### Returns

int

#

## Tags

None found

### setPrimaryKey()

    setPrimaryKey(int $key) : void

Generic method to set the primary key (id column).

#### Parameters

int | $key | Primary key.

#

## Tags

None found

### isPrimaryKeyNull()

    isPrimaryKeyNull() : boolean

Returns true if the primary key for this object is null.

#### Returns

boolean

#

## Tags

None found

### copyInto()

    copyInto(object $copyObj, boolean $deepCopy, boolean $makeNew)

Sets contents of passed object to values from current object.

If desired, this method can also make copies of all associated (fkey referrers) objects.

#### Parameters

object | $copyObj | An object of \Thelia\Model\Coupon (or compatible) type.
boolean | $deepCopy | Whether to also copy all rows that refer (by fkey) to the current row.
boolean | $makeNew | Whether to reset autoincrement PKs and make the object new.

#### Throws

\Propel\Runtime\Exception\PropelException

#

## Tags

None found

### copy()

    copy(boolean $deepCopy) : \Thelia\Model\Coupon

Makes a copy of this object that will be inserted as a new row in table when saved.

It creates a new object filling in the simple attributes, but skipping any primary keys that are defined for the table.

If desired, this method can also make copies of all associated (fkey referrers) objects.

#### Parameters

boolean | $deepCopy | Whether to also copy all rows that refer (by fkey) to the current row.

#### Throws

\Propel\Runtime\Exception\PropelException

#### Returns

\Thelia\Model\Coupon —

Clone of current object.

#

## Tags

None found

### initRelation()

    initRelation(string $relationName) : void

Initializes a collection based on the name of a relation.

Avoids crafting an 'init[$relationName]s' method name that wouldn't work when StandardEnglishPluralizer is used.

#### Parameters

string | $relationName | The name of the relation to initialize

#

## Tags

None found

### clearCouponRules()

    clearCouponRules() : void

Clears out the collCouponRules collection

This does not modify the database; however, it will remove any associated objects, causing them to be refetched by subsequent calls to accessor method.

#

See also

## Tags

None found

### resetPartialCouponRules()

    resetPartialCouponRules( $v)

Reset is the collCouponRules collection loaded partially.

#### Parameters

| $v |

#

## Tags

None found

### initCouponRules()

    initCouponRules(boolean $overrideExisting) : void

Initializes the collCouponRules collection.

By default this just sets the collCouponRules collection to an empty array (like clearcollCouponRules()); however, you may wish to override this method in your stub class to provide setting appropriate to your application -- for example, setting the initial array to the values stored in database.

#### Parameters

boolean | $overrideExisting | If set to true, the method call initializes the collection even if it is not empty

#

## Tags

None found

### getCouponRules()

    getCouponRules(\Propel\Runtime\ActiveQuery\Criteria $criteria, \Propel\Runtime\Connection\ConnectionInterface $con) : \Propel\Runtime\Collection\Collection|\Thelia\Model\CouponRule[]

Gets an array of ChildCouponRule objects which contain a foreign key that references this object.

If the $criteria is not null, it is used to always fetch the results from the database. Otherwise the results are fetched from the database the first time, then cached. Next time the same method is called without $criteria, the cached collection is returned. If this ChildCoupon is new, it will return an empty collection or the current collection; the criteria is ignored on a new object.

#### Parameters

\Propel\Runtime\ActiveQuery\Criteria | $criteria | optional Criteria object to narrow the query
\Propel\Runtime\Connection\ConnectionInterface | $con | optional connection object

#### Throws

\Propel\Runtime\Exception\PropelException

#### Returns

\Propel\Runtime\Collection\Collection|\Thelia\Model\CouponRule[] —

List of ChildCouponRule objects

#

## Tags

None found

### setCouponRules()

    setCouponRules(\Propel\Runtime\Collection\Collection $couponRules, \Propel\Runtime\Connection\ConnectionInterface $con) : \Thelia\Model\Coupon

Sets a collection of CouponRule objects related by a one-to-many relationship to the current object.

It will also schedule objects for deletion based on a diff between old objects (aka persisted) and new objects from the given Propel collection.

#### Parameters

\Propel\Runtime\Collection\Collection | $couponRules | A Propel collection.
\Propel\Runtime\Connection\ConnectionInterface | $con | Optional connection object

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### countCouponRules()

    countCouponRules(\Propel\Runtime\ActiveQuery\Criteria $criteria, boolean $distinct, \Propel\Runtime\Connection\ConnectionInterface $con) : int

Returns the number of related CouponRule objects.

#### Parameters

\Propel\Runtime\ActiveQuery\Criteria | $criteria |
boolean | $distinct |
\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Throws

\Propel\Runtime\Exception\PropelException

#### Returns

int —

Count of related CouponRule objects.

#

## Tags

None found

### addCouponRule()

    addCouponRule(\Thelia\Model\CouponRule $l) : \Thelia\Model\Coupon

Method called to associate a ChildCouponRule object to this object through the ChildCouponRule foreign key attribute.

#### Parameters

\Thelia\Model\CouponRule | $l | ChildCouponRule

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### removeCouponRule()

    removeCouponRule(\Thelia\Model\Base\CouponRule $couponRule) : \Thelia\Model\Coupon

#### Parameters

\Thelia\Model\Base\CouponRule | $couponRule | The couponRule object to remove.

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### clear()

    clear()

Clears the current object and sets all attributes to their default values

#

## Tags

None found

### clearAllReferences()

    clearAllReferences(boolean $deep)

Resets all references to other model objects or collections of model objects.

This method is a user-space workaround for PHP's inability to garbage collect objects with circular references (even in PHP 5.3). This is currently necessary when using Propel in certain daemon or large-volume/high-memory operations.

#### Parameters

boolean | $deep | Whether to also clear the references on all referrer objects.

#

## Tags

None found

### __toString()

    __toString() : string

Return the string representation of this object

#### Returns

string

#

## Tags

None found

### keepUpdateDateUnchanged()

    keepUpdateDateUnchanged() : \Thelia\Model\Coupon

Mark the current object so that the update date doesn't get updated during next save

#### Returns

\Thelia\Model\Coupon —

The current object (for fluent API support)

#

## Tags

None found

### preSave()

    preSave(\Propel\Runtime\Connection\ConnectionInterface $con) : boolean

Code to be run before persisting the object

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Returns

boolean

#

## Tags

None found

### postSave()

    postSave(\Propel\Runtime\Connection\ConnectionInterface $con)

Code to be run after persisting the object

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#

## Tags

None found

### preInsert()

    preInsert(\Propel\Runtime\Connection\ConnectionInterface $con) : boolean

Code to be run before inserting to database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Returns

boolean

#

## Tags

None found

### postInsert()

    postInsert(\Propel\Runtime\Connection\ConnectionInterface $con)

Code to be run after inserting to database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#

## Tags

None found

### preUpdate()

    preUpdate(\Propel\Runtime\Connection\ConnectionInterface $con) : boolean

Code to be run before updating the object in database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Returns

boolean

#

## Tags

None found

### postUpdate()

    postUpdate(\Propel\Runtime\Connection\ConnectionInterface $con)

Code to be run after updating the object in database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#

## Tags

None found

### preDelete()

    preDelete(\Propel\Runtime\Connection\ConnectionInterface $con) : boolean

Code to be run before deleting the object in database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Returns

boolean

#

## Tags

None found

### postDelete()

    postDelete(\Propel\Runtime\Connection\ConnectionInterface $con)

Code to be run after deleting the object in database

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#

## Tags

None found

### __call()

    __call(string $name, mixed $params) : array|string

Derived method to catches calls to undefined methods.

Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.). Allows to define default __call() behavior if you overwrite __call()

#### Parameters

string | $name |
mixed | $params |

#### Returns

array|string

#

## Tags

None found

### log()

    log(string $msg, int $priority) : boolean

Logs a message using Propel::log().

#### Parameters

string | $msg |
int | $priority | One of the Propel::LOG_* logging levels

#### Returns

boolean

#

## Tags

None found

### doSave()

    doSave(\Propel\Runtime\Connection\ConnectionInterface $con) : int

Performs the work of inserting or updating the row in the database.

If the object is new, it inserts it; otherwise an update is performed. All related objects are also updated in this method.

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Throws

\Propel\Runtime\Exception\PropelException

#### Returns

int —

The number of rows affected by this insert/update and any referring fk objects' save() operations.

#

See also

## Tags

None found

### doInsert()

    doInsert(\Propel\Runtime\Connection\ConnectionInterface $con)

Insert the row in the database.

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Throws

\Propel\Runtime\Exception\PropelException

#

See also

## Tags

None found

### doUpdate()

    doUpdate(\Propel\Runtime\Connection\ConnectionInterface $con) : Integer

Update the row in the database.

#### Parameters

\Propel\Runtime\Connection\ConnectionInterface | $con |

#### Returns

Integer —

Number of updated rows

#

See also

## Tags

None found

### doAddCouponRule()

    doAddCouponRule(\Thelia\Model\Base\CouponRule $couponRule)

#### Parameters

\Thelia\Model\Base\CouponRule | $couponRule | The couponRule object to add.

#

## Tags

None found

### Coupon.php